(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('rxjs'), require('@yukawa/chain-base-angular-domain'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-base-angular-client', ['exports', '@angular/common/http', '@angular/core', 'rxjs', '@yukawa/chain-base-angular-domain', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-base-angular-client'] = {}), global.ng.common.http, global.ng.core, global.rxjs, global['@yukawa/chain-base-angular-domain'], global.rxjs.operators));
}(this, (function (exports, i1, i0, rxjs, chainBaseAngularDomain, operators) { 'use strict';

    // import '@yukawa/chain-base-angular-domain/chaos-sys-core';
    // declare const SysType;
    var TAG = 'ConfigService';
    var ConfigService = /** @class */ (function () {
        function ConfigService(http) {
            this.http = http;
            /**
             * @deprecated
             */
            this.configUrl = "config.json";
            this.config = {};
        }
        /**
         * @deprecated
         */
        ConfigService.prototype.initConfig = function () {
            var _this = this;
            return new Promise(function (resolve, reject) {
                console.warn(TAG, "loadConfig is deprecated use initConfigs");
                _this.loadConfig()
                    .subscribe(function (data) {
                    _this.config = data;
                    resolve(true);
                }, function (error) {
                    console.error(TAG, "initConfig  " + error);
                    //reject(error)
                    return rxjs.throwError(error || 'Server error');
                });
            });
        };
        ConfigService.prototype.initConfigs = function (locations, rejectNotFound) {
            var _this = this;
            if (locations === void 0) { locations = ['config-base.json', 'config.json']; }
            if (rejectNotFound === void 0) { rejectNotFound = false; }
            return new Promise(function (resolve, reject) {
                var _loop_1 = function (idx) {
                    var loc = locations[idx];
                    _this.http.get(loc).subscribe(function (cfg) {
                        _this.config = chainBaseAngularDomain.SysType.objectMix(_this.config || {}, cfg);
                        //this.config = this.deepCopy(this.config||{}, cfg);
                        if (idx == locations.length - 1) {
                            resolve(_this.config);
                        }
                    }, function (error) {
                        if (rejectNotFound) {
                            reject(error);
                            return;
                        }
                        if (idx == locations.length - 1) {
                            resolve(_this.config);
                        }
                    });
                };
                for (var idx = 0; idx < locations.length; idx++) {
                    _loop_1(idx);
                }
            });
        };
        ConfigService.prototype.getBaseUrl = function (id) {
            if (id === void 0) { id = ""; }
            return id == "" ? this.config.baseUrl : this.config[id];
        };
        ConfigService.prototype.getValue = function (id) {
            return this.config[id];
        };
        ConfigService.prototype.formatUrl = function (id) {
            if (id === void 0) { id = "baseUrl"; }
            var cfg = this.config;
            if (!cfg)
                return cfg;
            cfg = cfg[id];
            if (cfg.startsWith('/') || cfg.startsWith(':'))
                cfg = this.config.baseUrl + cfg;
            return cfg;
        };
        /**
         * @deprecated
         */
        ConfigService.prototype.getConfig = function (id) {
            console.warn(TAG, "getConfig is deprecated use initConfigs");
            if (!id)
                return this.config;
            return "" + this.getBaseUrl() + this.config[id];
        };
        /**
         * @deprecated
         */
        ConfigService.prototype.loadConfig = function (url) {
            if (url === void 0) { url = 'config.json'; }
            console.warn(TAG, "loadConfig is deprecated use initConfigs " + url);
            return this.http.get(url);
        };
        return ConfigService;
    }());
    /** @nocollapse */ ConfigService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ConfigService_Factory() { return new ConfigService(i0.ɵɵinject(i1.HttpClient)); }, token: ConfigService, providedIn: "root" });
    ConfigService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ConfigService.ctorParameters = function () { return [
        { type: i1.HttpClient }
    ]; };
    function ConfigFactory(config) {
        return function () { return config.initConfigs(); };
    }
    function init() {
        return {
            provide: i0.APP_INITIALIZER,
            useFactory: ConfigFactory,
            deps: [ConfigService],
            multi: true
        };
    }
    var ConfigModule = {
        init: init
    };

    // @Injectable({
    //   providedIn: 'root'
    // })
    var UrlConfigService = /** @class */ (function () {
        function UrlConfigService(cfg, configService) {
            this.cfg = cfg;
            this.configService = configService;
            console.log("xxxxxxxxxxxxx");
        }
        UrlConfigService.prototype.getBackendUrl = function () {
            return this.configService.formatUrl(this.cfg);
        };
        return UrlConfigService;
    }());

    var TAG$1 = 'RestAspect';
    var RestAspect = /** @class */ (function () {
        function RestAspect(http, configService, serviceUrl) {
            this.http = http;
            this.configService = configService;
            this.serviceUrl = serviceUrl;
        }
        RestAspect.prototype.formatBaseUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.getBaseUrl('baseUrl') + path;
        };
        RestAspect.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.serviceUrl + path + '/';
        };
        Object.defineProperty(RestAspect.prototype, "verbose", {
            // noinspection JSMethodCanBeStatic
            get: function () {
                return i0.isDevMode();
            },
            enumerable: false,
            configurable: true
        });
        RestAspect.prototype.search = function (url, filter, method) {
            if (method === void 0) { method = 'post'; }
            var m = method || 'post';
            if (this.verbose)
                console.debug(TAG$1, "search:", m, url, filter);
            return this.http[m](url, filter).pipe(operators.map(function (r) {
                var result = {
                    took: r.took,
                    timedOut: r.timed_out,
                    rows: []
                };
                var h = r.hits;
                if (h) {
                    result.total = h.total;
                    for (var idx = 0; idx < h.hits.length; idx++) {
                        var hit = h.hits[idx];
                        var source = hit._source;
                        // console.log('DeviceService', hit);
                        result.rows.push(source);
                    }
                }
                return result;
            }));
        };
        RestAspect.prototype.query = function (url, filter, options) {
            if (options === void 0) { options = {}; }
            //options = this.defaultOptions(options);
            if (this.verbose)
                console.debug(TAG$1, "query:", url, filter);
            return this.http.post(url, filter, options).pipe(operators.map(function (data) { return chainBaseAngularDomain.QueryResult.fromData(data); }));
        };
        RestAspect.prototype.edit = function (url, value, options) {
            if (value === void 0) { value = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG$1, "edit:", url, value);
            return (options.method === 'put'
                ? this.http.put(url, value, options)
                : this.http.post(url, value, options)).pipe(operators.map(function (data) { return chainBaseAngularDomain.EditResult.fromData(data); }));
        };
        RestAspect.prototype.load = function (url, value, options) {
            if (value === void 0) { value = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG$1, "load:", url);
            var method = options.method || 'get';
            var obs;
            if (value) {
                obs = this.http[method](url, value, options);
            }
            else {
                obs = this.http[method](url, options);
            }
            return obs;
        };
        RestAspect.prototype.download = function (url, filter, options) {
            if (filter === void 0) { filter = null; }
            if (options === void 0) { options = {}; }
            if (this.verbose)
                console.debug(TAG$1, "download:", url, filter);
            options = options || {};
            options.responseType = options.responseType || 'blob';
            var method = options.method || 'post';
            return this.http[method](url, filter, options);
        };
        RestAspect.prototype.checkNotNull = function (value, message) {
            if (message === void 0) { message = "Not found"; }
            if (value == null)
                throw new Error(message);
            return value;
        };
        return RestAspect;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    // noinspection DuplicatedCode
    /**
     * ts impl of inc.yukawa.chain.base.rest.ctrl.RepoAspectRest
     */
    var RepoAspectRest = /** @class */ (function () {
        function RepoAspectRest(http, configService, urlKey) {
            if (urlKey === void 0) { urlKey = 'baseUrl'; }
            this.http = http;
            this.configService = configService;
            this.urlKey = urlKey;
        }
        Object.defineProperty(RepoAspectRest.prototype, "verbose", {
            // noinspection JSMethodCanBeStatic
            get: function () {
                return i0.isDevMode();
            },
            enumerable: false,
            configurable: true
        });
        RepoAspectRest.prototype.formatServiceUrl = function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl(this.urlKey) + path;
        };
        // -----------------------------------------------------------------------------------------------------------------
        RepoAspectRest.prototype.load = function (key) {
            var e_1, _a;
            var queryParamsList = [];
            if (key !== undefined && key !== null) {
                queryParamsList.push({ name: 'key', value: key.toString() });
            }
            var params = new i1.HttpParams();
            try {
                for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                    var queryParam = queryParamsList_1_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.http.get(this.formatServiceUrl('/'), { params: params });
        };
        RepoAspectRest.prototype.count = function (filter) {
            return this.http.post(this.formatServiceUrl('/count'), filter);
        };
        RepoAspectRest.prototype.find = function (filter) {
            return this.http.post(this.formatServiceUrl('/find'), filter);
        };
        RepoAspectRest.prototype.findKeys = function (filter) {
            return this.http.post(this.formatServiceUrl('/findKeys'), filter);
        };
        RepoAspectRest.prototype.query = function (filter) {
            return this.http.post(this.formatServiceUrl('/query'), filter)
                .pipe(operators.map(function (data) { return chainBaseAngularDomain.QueryResult.fromData(data); }));
        };
        // -----------------------------------------------------------------------------------------------------------------
        RepoAspectRest.prototype.put = function (entity) {
            return this.http.post(this.formatServiceUrl('/put'), entity);
        };
        RepoAspectRest.prototype.create = function (entity) {
            return this.http.post(this.formatServiceUrl('/create'), entity);
        };
        RepoAspectRest.prototype.update = function (entity) {
            return this.http.post(this.formatServiceUrl('/update'), entity);
        };
        RepoAspectRest.prototype.merge = function (entity) {
            return this.http.post(this.formatServiceUrl('/merge'), entity);
        };
        RepoAspectRest.prototype.edit = function (entity) {
            throw new Error('edit not implemented');
        };
        // -----------------------------------------------------------------------------------------------------------------
        RepoAspectRest.prototype.deleteByKey = function (key) {
            var e_2, _a;
            var queryParamsList = [];
            if (key !== undefined && key !== null) {
                queryParamsList.push({ name: 'key', value: key.toString() });
            }
            var params = new i1.HttpParams();
            try {
                for (var queryParamsList_2 = __values(queryParamsList), queryParamsList_2_1 = queryParamsList_2.next(); !queryParamsList_2_1.done; queryParamsList_2_1 = queryParamsList_2.next()) {
                    var queryParam = queryParamsList_2_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (queryParamsList_2_1 && !queryParamsList_2_1.done && (_a = queryParamsList_2.return)) _a.call(queryParamsList_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return this.http.delete(this.formatServiceUrl('/'), { params: params });
        };
        RepoAspectRest.prototype.delete = function (entity) {
            return this.http.post(this.formatServiceUrl('/delete'), entity);
        };
        RepoAspectRest.prototype.deleteAll = function (filter) {
            return this.http.post(this.formatServiceUrl('/deleteAll'), filter);
        };
        return RepoAspectRest;
    }());

    var InterceptedRepoAspectsRest = /** @class */ (function (_super) {
        __extends(InterceptedRepoAspectsRest, _super);
        function InterceptedRepoAspectsRest(http, configService, urlKey) {
            return _super.call(this, http, configService, urlKey) || this;
        }
        InterceptedRepoAspectsRest.prototype.load = function (key) {
            var _this = this;
            return this.beforeLoad(key)
                .pipe(operators.mergeMap(function (key) { return _super.prototype.load.call(_this, key); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterLoad(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.find = function (filter) {
            var _this = this;
            return this.beforeRead(filter)
                .pipe(operators.mergeMap(function (filter) { return _super.prototype.find.call(_this, filter); }))
                .pipe(operators.concatAll())
                .pipe(operators.concatMap(function (res) { return _this.afterRead(res); }))
                .pipe(operators.toArray());
        };
        InterceptedRepoAspectsRest.prototype.query = function (filter) {
            var _this = this;
            return this.beforeRead(filter)
                .pipe(operators.mergeMap(function (filter) { return _super.prototype.query.call(_this, filter); }))
                .pipe(operators.mergeMap(function (res) { return _this.afterQuery(res); }));
        };
        InterceptedRepoAspectsRest.prototype.create = function (entity) {
            var _this = this;
            return this.beforeWrite(entity)
                .pipe(operators.mergeMap(function (entity) { return _super.prototype.create.call(_this, entity); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterWrite(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.update = function (entity) {
            var _this = this;
            return this.beforeWrite(entity)
                .pipe(operators.mergeMap(function (entity) { return _super.prototype.update.call(_this, entity); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterWrite(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.merge = function (entity) {
            var _this = this;
            return this.beforeWrite(entity)
                .pipe(operators.mergeMap(function (entity) { return _super.prototype.merge.call(_this, entity); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterWrite(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.put = function (entity) {
            var _this = this;
            return this.beforeWrite(entity)
                .pipe(operators.mergeMap(function (entity) { return _super.prototype.put.call(_this, entity); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterWrite(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.deleteByKey = function (key) {
            var _this = this;
            return this.beforeDelete(key)
                .pipe(operators.mergeMap(function (key) { return _super.prototype.deleteByKey.call(_this, key); }))
                .pipe(operators.mergeMap(function (entity) { return _this.afterDelete(entity); }));
        };
        InterceptedRepoAspectsRest.prototype.beforeLoad = function (key) {
            return rxjs.of(key);
        };
        ;
        InterceptedRepoAspectsRest.prototype.beforeRead = function (filter) {
            return rxjs.of(filter);
        };
        InterceptedRepoAspectsRest.prototype.beforeWrite = function (entity) {
            return rxjs.of(entity);
        };
        InterceptedRepoAspectsRest.prototype.beforeDelete = function (key) {
            return rxjs.of(key);
        };
        InterceptedRepoAspectsRest.prototype.afterLoad = function (entity) {
            return rxjs.of(entity);
        };
        InterceptedRepoAspectsRest.prototype.afterRead = function (entity) {
            return rxjs.of(entity);
        };
        InterceptedRepoAspectsRest.prototype.afterQuery = function (result) {
            return rxjs.of(result);
        };
        InterceptedRepoAspectsRest.prototype.afterWrite = function (entity) {
            return rxjs.of(entity);
        };
        InterceptedRepoAspectsRest.prototype.afterDelete = function (entity) {
            return rxjs.of(entity);
        };
        return InterceptedRepoAspectsRest;
    }(RepoAspectRest));

    var CachedRepoAspectRest = /** @class */ (function (_super) {
        __extends(CachedRepoAspectRest, _super);
        function CachedRepoAspectRest(http, configService, urlKey, keyExtractor) {
            var _this = _super.call(this, http, configService, urlKey) || this;
            _this.keyExtractor = keyExtractor;
            _this.idCache = {};
            _this.idCacheRefreshSubjects = {};
            _this.queryCacheRefreshSubject = new rxjs.Subject();
            return _this;
        }
        CachedRepoAspectRest.prototype.query = function (filter) {
            var _this = this;
            if (!this.queryCache) {
                this.queryCache = this.queryCacheRefreshSubject
                    .pipe(operators.delay(1500))
                    .pipe(operators.startWith(""))
                    .pipe(operators.switchMap(function () { return _super.prototype.query.call(_this, filter); }))
                    .pipe(operators.shareReplay(1));
            }
            return this.queryCache;
        };
        CachedRepoAspectRest.prototype.load = function (key) {
            var _this = this;
            if (!this.getRefreshSubject(key)) {
                this.idCacheRefreshSubjects[key.toString()] = new rxjs.Subject();
            }
            if (!this.getCachedEntityObservable(key)) {
                this.idCache[key.toString()] = this.getRefreshSubject(key)
                    .pipe(operators.delay(1500))
                    .pipe(operators.startWith(""))
                    .pipe(operators.switchMap(function () { return _super.prototype.load.call(_this, key); }))
                    .pipe(operators.shareReplay(1));
            }
            return this.getCachedEntityObservable(key);
        };
        CachedRepoAspectRest.prototype.update = function (entity) {
            return _super.prototype.update.call(this, entity).pipe(this.refreshOp(entity));
        };
        CachedRepoAspectRest.prototype.merge = function (entity) {
            return _super.prototype.merge.call(this, entity).pipe(this.refreshOp(entity));
        };
        CachedRepoAspectRest.prototype.put = function (entity) {
            return _super.prototype.put.call(this, entity).pipe(this.refreshOp(entity));
        };
        CachedRepoAspectRest.prototype.edit = function (entity) {
            return _super.prototype.edit.call(this, entity).pipe(this.refreshOp(entity));
        };
        CachedRepoAspectRest.prototype.refreshOp = function (entity) {
            var _this = this;
            return operators.tap(function () {
                _this.refreshCaches(entity);
            });
        };
        CachedRepoAspectRest.prototype.refresh = function () {
        };
        CachedRepoAspectRest.prototype.refreshCaches = function (entity) {
            this.refreshEntityCache(this.keyExtractor(entity));
            this.refreshQueryCache();
        };
        CachedRepoAspectRest.prototype.getCachedEntityObservable = function (key) {
            return this.idCache[key.toString()];
        };
        CachedRepoAspectRest.prototype.getRefreshSubject = function (key) {
            return this.idCacheRefreshSubjects[key.toString()];
        };
        CachedRepoAspectRest.prototype.refreshEntityCache = function (key) {
            if (this.getRefreshSubject(key)) {
                this.getRefreshSubject(key).next();
            }
        };
        CachedRepoAspectRest.prototype.refreshQueryCache = function () {
            this.queryCacheRefreshSubject.next();
        };
        return CachedRepoAspectRest;
    }(InterceptedRepoAspectsRest));

    /*
     * Public API Surface of chain-base-angular-client
     */
    //import 'chaos-sys-core-1.9.3-SNAPSHOT.min.js';
    //export var SysType:  any;

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CachedRepoAspectRest = CachedRepoAspectRest;
    exports.ConfigFactory = ConfigFactory;
    exports.ConfigModule = ConfigModule;
    exports.ConfigService = ConfigService;
    exports.InterceptedRepoAspectsRest = InterceptedRepoAspectsRest;
    exports.RepoAspectRest = RepoAspectRest;
    exports.RestAspect = RestAspect;
    exports.UrlConfigService = UrlConfigService;
    exports.init = init;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-base-angular-client.umd.js.map
