import { HttpClient } from "@angular/common/http";
import { ConfigService } from "../config/config.service";
import { CachedRepoAspect, QueryResult } from "@yukawa/chain-base-angular-domain";
import { Observable, Subject } from "rxjs";
import { InterceptedRepoAspectsRest } from "./intercepted-repo-aspects-rest";
export declare class CachedRepoAspectRest<K, V, F> extends InterceptedRepoAspectsRest<K, V, F> implements CachedRepoAspect<K, V, F> {
    keyExtractor: (entity: V) => K;
    idCache: {
        [key: string]: Observable<V>;
    };
    idCacheRefreshSubjects: {
        [key: string]: Subject<any>;
    };
    queryCache: Observable<QueryResult<V>>;
    queryCacheRefreshSubject: Subject<any>;
    constructor(http: HttpClient, configService: ConfigService, urlKey: string, keyExtractor: (entity: V) => K);
    query(filter: F): Observable<QueryResult<V>>;
    load(key: K): Observable<V>;
    update(entity: V): Observable<V>;
    merge(entity: V): Observable<V>;
    put(entity: V): Observable<V>;
    edit(entity: V): Observable<V>;
    private refreshOp;
    refresh(): void;
    private refreshCaches;
    private getCachedEntityObservable;
    private getRefreshSubject;
    refreshEntityCache(key: K): any;
    refreshQueryCache(): void;
}
